import { createRouter, createWebHistory } from 'vue-router'
// 导入所有 view 页面
import PkIndexView from '../views/pk/PkIndexView.vue'
import RanklistIndexView from '../views/ranklist/RanklistIndexView.vue'
import RecordIndexView from '../views/record/RecordIndexView.vue'
import UserBotIndexView from '../views/user/bot/UserBotIndexView.vue'
import NotFound from '../views/error/NotFound.vue'
import UserAccountLoginView from '@/views/user/account/UserAccountLoginView.vue'
import UserAccountRegisterView from '@/views/user/account/UserAccountRegisterView.vue'


// 定义所有页面的 URL 路由
const routes = [
  {
    path:'/',
    name:'home',
    // 重定向:将 home 重定向到 pk 页面
    redirect:'/pk/'
  },
  {
    path:'/pk/',
    name:'pk_index',
    component:PkIndexView
  },
  {
    path:'/ranklist/',
    name:'ranklist_index',
    component:RanklistIndexView
  },
  {
    path:'/record/',
    name:'record_index',
    component:RecordIndexView
  },
  {
    path:'/user/bot/',
    name:'user_bot_index',
    component:UserBotIndexView
  },
  {
    path:'/user/account/login/',
    name:'user_account_login',
    component:UserAccountLoginView
  },
  {
    path:'/user/account/register/',
    name:'user_account_register',
    component:UserAccountRegisterView
  },
  {
    path:'/404/',
    name:'404',
    component:NotFound
  },
  {
    // 正则匹配所有其他非法页面到 404
    path:'/:catchAll(.*)',
    redirect:'/404/'
  }
]

const router = createRouter({
  history: createWebHistory(),
  routes
})

export default router